<template>
	<div>
		<h3>
			Отделы
		</h3>
		<a-tabs :style="{ width: '100%' }" defaultActiveKey="1" @change="callback">
		    <a-tab-pane tab="Все отделы" key="1">
		    	<table class="table">
				  <thead>
				    <tr>
				      <th scope="col">Название</th>
				      <th scope="col">Сотрудников</th>
				      <th scope="col">Создан</th>
				      <th scope="col">Обновлен</th>
				      <th scope="col"><span class="d-flex justify-content-end">Действия</span></th>
				    </tr>
				  </thead>
				  <tbody>
				    <tr v-for="department in departments" :key="department.id">
				      <th scope="row">{{ department.name }}</th>
				      <td>{{ department.users.length }}</td>
				      <td>{{ department.created_at }}</td>
				      <td>{{ department.updated_at }}</td>
				      <td class="d-flex justify-content-end">
				      	<a-button-group>
							<a-button type="primary" icon="edit" />
							<a-button @click="deleteDepartment(department.id, department.users.length)" type="danger" icon="delete" />
						</a-button-group>
				      </td>
				    </tr>
				  </tbody>
				</table>
		    </a-tab-pane>
		    <a-tab-pane tab="Новый отдел" key="2" forceRender>
		    	<div class="row">
		    		<div class="col-6">
		    			<form>
					      	<div class="form-group">
					      		<a-input placeholder="Название" v-model="add.name"/>
					      	</div>
					      	<div class="form-group">
					      		<a-textarea placeholder="Описание" :autosize="{ minRows: 6, maxRows: 30 }" v-model="add.description"/>
					      	</div>
					      	<div class="form-group d-flex justify-content-end">
					      		<div style="display: inline-block;">
					      			<a-button type="primary" @click="addDepartment">Отправить</a-button>
					      		</div>
					      	</div>
					    </form>	
		    		</div>
		    	</div>
		    </a-tab-pane>
		</a-tabs>
	</div>
</template>

<script type="text/javascript">
	export default {
		data() {
			return {
				departments: '',
      			add: {
      				name: '',
      				description: ''
      			}
			}
		},
		created() {
			this.loadData()
		},
		methods: {
			loadData() {
				this.$http.get(this.$store.state.api.root+'/api/v1/getAllDepartments')
				.then(this.loadDataSuccess,this.loadDataError)
			},
			loadDataSuccess(res) {
				this.departments = res.body
			},
			loadDataError(err) {

			},
		    addDepartment() {
		    	let params = {
		    		name: this.add.name,
		    		description: this.add.description
		    	}
		    	this.$http.post(this.$store.state.api.root+'/api/v1/addDepartment', params)
		    	.then(this.addDepartmentSuccess,this.addDepartmentError)
		    },
		    addDepartmentSuccess(res) {
		    	if (this.add.name === '') {
		    		this.$message.error('Заполните название отдела');
		    		return false;
		    	}
		    	this.$message.success('Отдел добавлен');
		    	this.loadData()
		    	this.add.name = ''
		    	this.add.description = ''
		    	this.visible = false
		    	this.loading = false
		    },
		    addDepartmentError(err) {
		    	if (err.status === 422) {
		    		this.loading = false
		    		this.$message.error('Этот отдел уже существует');
		    	}
		    },
		    deleteDepartment(id, count) {
		    	if (count > 0) {
		    		this.$notification['error']({
			          message: 'Ошибка',
			          description: 'Нельзя удалить отдел с сотрудниками!',
			        });
		    	}
		    }
		}
	}
</script>